#include "board.h"

const PinDescription_t pins[] = {
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 1 - POWER SUPPLY DECOUPLING 1
	{PORT0, 0, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 2 - P0.00 - LOW-FREQUENCY CLOCK 1
	{PORT0, 1, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 3 - P0.01 - LOW-FREQUENCY CLOCK 2
	{PORT0, 2, PIN_ANALOG, PIN_ATTR_ANALOG, ADC_A0, NOT_ON_PWM}, // PIN 4 - P0.02 - AIN0
	{PORT0, 3, PIN_ANALOG, PIN_ATTR_ANALOG, ADC_A1, NOT_ON_PWM}, // PIN 5 - P0.03 - AIN1
	{PORT0, 4, PIN_ANALOG, PIN_ATTR_ANALOG, ADC_A2, NOT_ON_PWM}, // PIN 6 - P0.04 - AIN2
	{PORT0, 5, PIN_ANALOG, PIN_ATTR_ANALOG, ADC_A3, NOT_ON_PWM}, // PIN 7 - P0.05 - AIN3
	{PORT0, 6, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM0}, // PIN 8 - P0.06 - PWM0 - USER_LED_R
	{PORT0, 7, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM1}, // PIN 9 - P0.07 - PWM1 - USER_LED_G
	{PORT0, 8, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM2}, // PIN 10 - P0.08 - PWM2 - USER_LED_B
	{PORT0, 9, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 11 - P0.09 - NFC1
	{PORT0, 10, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 12 - P0.10 - NFC2
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 13 - VDD
	{PORT0, 11, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 14 - P0.11 - UART_RX
	{PORT0, 12, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 15 - P0.12 - UART_TX
	{PORT0, 13, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 16 - P0.13 - I2C0_SDA
	{PORT0, 14, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 17 - P0.14 - I2C0_SCL
	{PORT0, 15, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 18 - P0.15 - I2C1_SDA
	{PORT0, 16, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 19 - P0.16 - I2C1_SCL
	{PORT0, 17, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM3}, // PIN 20 - P0.17 - PWM3
	{PORT0, 18, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM4}, // PIN 21 - P0.18 - PWM4
	{PORT0, 19, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM5}, // PIN 22 - P0.19 - PWM5
	{PORT0, 20, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM6}, // PIN 23 - P0.20 - PWM6
	{PORT0, 21, PIN_INPUT, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 24 - RESET
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 25 - SWDCLK
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 26 - SWDIO
	{PORT0, 22, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM7}, // PIN 27 - P0.22 - PWM7
	{PORT0, 23, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM8}, // PIN 28 - P0.23 - PWM8
	{PORT0, 24, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM9}, // PIN 29 - P0.24 - PWM9
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 30 - ANT
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 31 - GND
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 32 - POWER SUPPLY DECOUPLING 2
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 33 - POWER SUPPLY DECOUPLING 3
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 34 - HIGH-FREQUENCY CLOCK 1
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 35 - HIGH-FREQUENCY CLOCK 2
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 36 - VDD
	{PORT0, 25, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 37 - P0.25 - SPI0_MOSI
	{PORT0, 26, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 38 - P0.26 - SPI0_MISO
	{PORT0, 27, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 39 - P0.27 - SPI0_SCK
	{PORT0, 28, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM10}, // PIN 40 - P0.28 - PWM10
	{PORT0, 29, PIN_DIGITAL, (PIN_ATTR_DIGITAL | PIN_ATTR_PWM), NO_ADC, PWM11}, // PIN 41 - P0.29 - PWM11
	{PORT0, 30, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 42 - P0.30 - POWER_LED
	{PORT0, 31, PIN_DIGITAL, PIN_ATTR_DIGITAL, NO_ADC, NOT_ON_PWM}, // PIN 43 - P0.31 - USER_BTN
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 44 - NC
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 45 - GND
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 46 - POWER SUPPLY DECOUPLING 4
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 47 - DC/DC OUTPUT
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM}, // PIN 48 - VDD
	{PNUL, 0, NOT_A_PIN, PIN_ATTR_NONE, NO_ADC, NOT_ON_PWM} // PIN 49 - EXPOSED PAD - GND
};

uint32_t bootloader_version = 0;

void init(void) {
	//SystemInit();

	// configure and start clock
	CLOCK->LFCLKSRC = (uint32_t) ((CLOCK_LFCLKSRC_SRC_XTAL << CLOCK_LFCLKSRC_SRC_Pos) & CLOCK_LFCLKSRC_SRC_Msk);
	CLOCK->TASKS_LFCLKSTART = 1;

	// retrieve bootloader version
	bootloader_version = TIMER2->CC[0];

	// RTC1 could be enabled by bootloader, disable it
	NVIC_DisableIRQ(RTC1_IRQn);
	RTC1->EVTENCLR = RTC_EVTEN_COMPARE0_Msk;
	RTC1->INTENCLR = RTC_INTENSET_COMPARE0_Msk;
	RTC1->TASKS_STOP = 1;
	RTC1->TASKS_CLEAR = 1;

	// make sure all pins are set HIGH when setPinMode() is called
	//GPIO->OUTSET = 0xFFFFFFFF;
	GPIO->PIN_CNF[14] = ((uint32_t) GPIO_PIN_CNF_DIR_OUTPUT << GPIO_PIN_CNF_DIR_Pos) |
				((uint32_t) GPIO_PIN_CNF_INPUT_DISCONNECT << GPIO_PIN_CNF_INPUT_Pos) |
				((uint32_t) GPIO_PIN_CNF_NOPULL << GPIO_PIN_CNF_PULL_Pos) |
				((uint32_t) GPIO_PIN_CNF_DRIVE_H0H1 << GPIO_PIN_CNF_DRIVE_Pos) |
				((uint32_t) GPIO_PIN_CNF_NOSENSE << GPIO_PIN_CNF_SENSE_Pos);
	GPIO->OUTSET = (1UL << 14);
}
