#ifndef COMPONENT_TIMER_H
#define COMPONENT_TIMER_H

/** SOFTWARE API DEFINITION FOR Timer **/

typedef struct {
	__O uint32_t TASKS_START; // Offset: 0x000 - Start Timer
	__O uint32_t TASKS_STOP; // Offset: 0x004 - Stop Timer
	__O uint32_t TASKS_COUNT; // Offset: 0x008 - Increment Timer (Counter Mode Only)
	__O uint32_t TASKS_CLEAR; // Offset: 0x00C - Clear Timer
	__O uint32_t TASKS_SHUTDOWN; // Offset: 0x010 - Shutdown Timer
	__I uint32_t RESERVED0[11];
	__O uint32_t TASKS_CAPTURE[6]; // Offset: 0x040 - Capture Timer Value to CC Registers
	__I uint32_t RESERVED1[58];
	__IO uint32_t EVENTS_COMPARE[6]; // Offset: 0x140 - Compare Event on CC Match
	__I uint32_t RESERVED2[42];
	__IO uint32_t SHORTS; // Offset: 0x200 - Shortcut Register
	__I uint32_t RESERVED3[64];
	__IO uint32_t INTENSET; // Offset: 0x304 - Interrupt Enable Set Register
	__IO uint32_t INTENCLR; // Offset: 0x308 - Interrupt Enable Clear Register
	__I uint32_t RESERVED4[126];
	__IO uint32_t MODE; // Offset: 0x504 - Timer Mode Selection
	__IO uint32_t BITMODE; // Offset: 0x508 - Number of Bits Used by the Timer
	__I uint32_t RESERVED5;
	__IO uint32_t PRESCALER; // Offset: 0x510 - Timer Prescaler Register
	__I uint32_t RESERVED6[11];
	__IO uint32_t CC[6]; // Offset: 0x540 - Capture/Compare Registers
} Timer_t;

#endif
